#include "cstdlib"
#include "iostream"
#include <cstdio>
#include <AL/al.h>
#include <AL/alc.h>
#include "SDL/SDL.h"

using namespace std;





int main() {
  SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER);

  SDL_Surface* sl1=SDL_SetVideoMode(200,200,16,SDL_SWSURFACE);
  SDL_Event gameover,mouse;Uint8* key;int quit=0,c=0,d=0,e=0,f=0,g=0;
  unsigned int oldTime=0,currentTime=0,framerate=8;//1000/10=100fps
  
  
  FILE* fp = NULL;
  fp = fopen("FRED.WAV","rb");
  
  
  char type[4];
  int size,chunkSize;
  short formatType,channels;
  int sampleRate,avgBytesPerSec;
  short bytesPerSample,bitsPerSample;
  int dataSize;
  
  fread(type,1,4,fp);
  cout<<type[0]<<"   "<<type[1]<<"   "<<type[2]<<"   "<<type[3]<<endl;
  
  fread(&size,4,1,fp);
  
  fread(type,1,4,fp);
  cout<<type[0]<<"   "<<type[1]<<"   "<<type[2]<<"   "<<type[3]<<endl;
  
  fread(type,1,4,fp);
  cout<<type[0]<<"   "<<type[1]<<"   "<<type[2]<<"   "<<type[3]<<endl;
  
  fread(&chunkSize,4,1,fp);
  fread(&formatType,2,1,fp);
  fread(&channels,2,1,fp);
  fread(&sampleRate,4,1,fp);
  fread(&avgBytesPerSec,4,1,fp);
  fread(&bytesPerSample,2,1,fp);
  fread(&bitsPerSample,2,1,fp);
  
  cout<<"chunkSize = "<<chunkSize<<endl;
  cout<<"formatType = "<<formatType<<endl;
  cout<<"channels = "<<channels<<endl;
  cout<<"sampleRate = "<<sampleRate<<endl;
  cout<<"avgBytesPerSec = "<<avgBytesPerSec<<endl;
  cout<<"bytesPerSample = "<<bytesPerSample<<endl;
  cout<<"bitsPerSample = "<<bitsPerSample<<endl;
  
  if(chunkSize==18){fread(type,1,2,fp);}
  fread(type,1,4,fp);
  cout<<type[0]<<"   "<<type[1]<<"   "<<type[2]<<"   "<<type[3]<<endl;
  
  fread(&dataSize,4,1,fp);
  cout<<"dataSize   "<<dataSize<<endl;
  
  unsigned char* buf= new unsigned char[dataSize];
  fread(buf,1,dataSize,fp);
  
  
  ALCdevice *device;
  ALCcontext *context;
  device = alcOpenDevice(NULL);
  if(!device){cout<<"ERROR device"<<endl;}else{cout<<"device FINE!"<<endl;}
  
  context = alcCreateContext(device, NULL);
  if(!context){cout<<"ERROR context"<<endl;}else{cout<<"context FINE!"<<endl;}
  
  alcMakeContextCurrent(context);
  
  
  
  ALuint source;
  ALuint buffer;
  ALuint frequency=sampleRate;
  ALenum format=0;
  
  alGenBuffers(1,&buffer);
  alGenSources(1,&source);
  
  
  
  if(bitsPerSample == 8){
    if(channels == 1){format = AL_FORMAT_MONO8;}
    else{format=AL_FORMAT_STEREO8;}
  }
  
  if(bitsPerSample == 16){
    if(channels == 1){format = AL_FORMAT_MONO16;}
    else{format=AL_FORMAT_STEREO16;}
  }
  
  
  alBufferData(buffer, format, buf, dataSize, frequency);
  
  
  ALfloat SourcePos[] = {0.0, 0.0, 0.0};
  ALfloat SourceVel[] = {0.0, 0.0, 0.0};
  ALfloat ListenerPos[] = {0.0, 0.0, 0.0};
  ALfloat ListenerVel[] = {0.0, 0.0, 0.0};
  ALfloat ListenerOri[] = {0.0, 0.0, -1.0, 0.0, 1.0, 0.0};
  
  // Listener
  alListenerfv(AL_POSITION, ListenerPos);
  alListenerfv(AL_VELOCITY, ListenerVel);
  alListenerfv(AL_ORIENTATION, ListenerOri);
  alListenerf(AL_GAIN,1.0);
  
  // Source
  alSourcei(source,AL_BUFFER,buffer);
  alSourcef(source,AL_PITCH,1.0);
  alSourcef(source,AL_GAIN,1.0);
  alSourcefv(source,AL_POSITION,SourcePos);
  alSourcefv(source,AL_VELOCITY,SourceVel);
  alSourcei(source,AL_LOOPING, AL_TRUE);
  
  
  alSourcePlay(source);
  //alSourcePause(source);
  //alSourceStop(source);
while(quit==0){

while(SDL_PollEvent(&gameover))
{if(gameover.type==SDL_QUIT){quit=1;}}

key=SDL_GetKeyState(NULL);
if(key[SDLK_ESCAPE]){quit=1;}
  
currentTime=SDL_GetTicks();
if(currentTime-oldTime<framerate)
{SDL_Delay(framerate-(currentTime-oldTime));}
oldTime=SDL_GetTicks();}
  
  //SDL_Delay(60000*5);
  fclose(fp);
  delete[] buf;
  alDeleteSources(1,&source);
  alDeleteBuffers(1,&buffer);
  alcMakeContextCurrent(NULL);
  alcDestroyContext(context);
  alcCloseDevice(device);
  

  
        return 0;
}